unit TestFilterColumn_main;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, ExtCtrls, ComCtrls,
  Grids, IniPropStorage;

type

  { TForm1 }

  TForm1 = class(TForm)
    IniPropStorage1: TIniPropStorage;
    Panel1: TPanel;
    StatusBar1: TStatusBar;
    StringGrid1: TStringGrid;
    procedure FormCreate(Sender: TObject);
    procedure Panel1Click(Sender: TObject);
    procedure StringGrid1DblClick(Sender: TObject);
    procedure StringGrid1HeaderClick(Sender: TObject; IsColumn: Boolean;
      Index: Integer);
  private

  public

  end;

var
  Form1: TForm1;

const
  workfile='sensor20.csv';
  capPanel='Filter mit Doppelklick auf Zelle; Reset mit Klick auf Header';

implementation

{$R *.lfm}

{ TForm1 }

function FilterColumn(var aGrid: TStringGrid;
                      const aCol: integer; aText: string): integer;
var
  i: integer;

begin
  result:=0;
  aGrid.BeginUpdate;
  try
    for i:=aGrid.FixedRows to aGrid.RowCount-1 do begin
      if aGrid.Cells[aCol, i]=aText then begin
        aGrid.RowHeights[i]:=aGrid.DefaultRowHeight;
        result:=result+1;
      end else
        aGrid.RowHeights[i]:=0;
    end;
  finally
    aGrid.EndUpdate;
  end;
end;

procedure ResetAllFilterColumn(var aGrid: TStringGrid);
var
  i: integer;

begin
  aGrid.BeginUpdate;
  try
    for i:=aGrid.FixedRows to aGrid.RowCount-1 do
      aGrid.RowHeights[i]:=aGrid.DefaultRowHeight;
  finally
    aGrid.EndUpdate;
  end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  Panel1.Caption:=capPanel;
  StringGrid1.LoadFromCSVFile(IncludeTrailingPathDelimiter(Application.Location)+workfile, ';');
  StringGrid1.AutoSizeColumn(5);
  StatusBar1.SimpleText:=workfile;
end;

procedure TForm1.Panel1Click(Sender: TObject);
begin
  ResetAllFilterColumn(StringGrid1);
  StatusBar1.SimpleText:=workfile;
end;

procedure TForm1.StringGrid1DblClick(Sender: TObject);
var
  matches: integer;

begin
  if (StringGrid1.Col>0) and (StringGrid1.Col<>2) then begin   // sinnlos für 1. und 3. Spalte
    matches:=FilterColumn(StringGrid1, StringGrid1.Col,
                          StringGrid1.Cells[StringGrid1.Col, StringGrid1.Row]);
    StatusBar1.SimpleText:=format('%d Treffer aus %d Zeilen', [matches, StringGrid1.RowCount-1]);
  end else begin
    ResetAllFilterColumn(StringGrid1);
    StatusBar1.SimpleText:=workfile;
  end;
end;

procedure TForm1.StringGrid1HeaderClick(Sender: TObject; IsColumn: Boolean;
  Index: Integer);
begin
  ResetAllFilterColumn(StringGrid1);
  StatusBar1.SimpleText:=workfile;
end;

end.

